debug_mode = 1

.286
cseg   segment byte public
       assume  cs:cseg

       org     100h

start:
       push    ds
       push    es
       pusha
       push    cs                      ;ன ॣ஢ ds,es 
       pop     ax                      ;
       mov     ds,ax
       mov     bx,es:[7B0h]
       cmp     bx,0
       je      done_2
       mov     word ptr boot_disk,bx
  done_2:
       mov     es,ax
       mov     ax,0003h                ;४砥  ० 25x80
       int     10h                     ; 頥 ࠭
       call    near ptr set_up_font
       mov     ah,1                    ;  
       mov     cx,2000h
       int     10h
       call    near ptr show_menu               ;뢮  ࠭ 
wait_key:
       call    near ptr show_cursor
       call    near ptr show_boot_disk
       call    near ptr show_status_disk
       mov     ax,0
       int     16h
       push    ax
       call    near ptr hide_cursor
       call    near ptr hide_boot_disk
       pop     ax
       cmp     ah,50h
       je      press_down
       cmp     ah,48h
       je      press_up
       cmp     ah,30h
       je      press_boot
       cmp     al,2bh
       je      press_plus
       cmp     al,2dh
       je      press_minus
       cmp     al,0dh
       je      go_boot_temp              ;   127 , ⮬
       jmp     short wait_key            ; je  ࠡ⠥, ᮡࠥ
go_boot_temp:                            ; -㣮
       jmp     go_boot
press_down:
       cmp     cur_disk,3
       je      go_first_line
       inc     cur_disk
       jmp     short wait_key
go_first_line:
       mov     cur_disk,1
       jmp     short wait_key
press_up:
       cmp     cur_disk,1
       je      go_last_line
       dec     cur_disk
       jmp     short wait_key
go_last_line:
       mov     cur_disk,3
       jmp     short wait_key
press_boot:
       call    near ptr check_active_disk
       jnc     short wait_key
       mov     al,cur_disk
       mov     boot_disk,al
       jmp     short wait_key
press_plus:
       mov     cl,cur_disk
       mov     al,status_disk
       ror     al,cl
       rol     al,1
       or      al,1
       ror     al,1
       rol     al,cl
       mov     status_disk,al
       jmp     wait_key
press_minus:
       mov     al,cur_disk
       cmp     al,boot_disk
       jne     done_01
       jmp     wait_key
  done_01:
       mov     cl,cur_disk
       mov     al,status_disk
       ror     al,cl
       rol     al,1
       and     al,0feh
       ror     al,1
       rol     al,cl
       mov     status_disk,al
       jmp     wait_key
go_boot:
       call    near ptr show_boot_disk
       call    near ptr show_status_disk
       call    near ptr resetup_partition
       mov     bx,word ptr boot_disk
       mov     es:[7B0h],bx
       popa
       mov     si,new_si
       
if debug_mode eq 0
       pop     es                     
       pop     ds                     
       retf                           
endif

if debug_mode eq 1
       mov     ax,4c00h                ;⮯ ணࠬ
       int     21h
endif

write_str:
       lodsb                           ; 뢮 ᮮ饭  ࠭
       cmp     al,0                    ;  ० ⥫⠩
       je      end_write_str           ; 室, ᫨ 
                                       ; ᮮ饭
       push    si                      ;  㪠⥫
       mov     bx,7
       mov     ah,0eh
       int     10h                     ; 뢮  ࠭

       pop     si                      ; ⠭ 㪠⥫
       jmp     short write_str         ; த 뢮 ᮮ饭
end_write_str:
       retn

show_menu:
       mov     ah,2
       mov     dx,0
       mov     bh,0
       int     10h
       mov     si,offset menu
       call    near ptr write_str
       retn

show_char:
       push    ax
       mov     ah,2
       mov     bh,0
       int     10h
       pop     ax
       mov     ah,9
       mov     cx,1
       int     10h
       retn

show_cursor:
       mov     al,''
       mov     dl,1
       mov     dh,cur_disk
       mov     bx,7                          ;87
       call    near ptr show_char
       retn

hide_cursor:
       mov     al,' '
       mov     dl,1
       mov     dh,cur_disk
       mov     bx,7
       call    near ptr show_char
       retn

show_boot_disk:
       mov     al,'B'
       mov     dl,3
       mov     dh,boot_disk
       mov     bx,7
       call    near ptr show_char
       retn

hide_boot_disk:
       mov     al,' '
       mov     dl,3
       mov     dh,boot_disk
       mov     bx,7
       call    near ptr show_char
       retn

show_status_disk:
       mov     cx,3
       mov     al,status_disk
       shl     al,5
  scan_disk:
       push    cx
       shl     al,1
       push    ax
       jnc     non_status
       mov     al,'+'
       jmp     done
  non_status:
       mov     al,'-'
  done:
       mov     dl,4
       mov     dh,cl
       mov     bx,7
       call    near ptr show_char
       pop     ax
       pop     cx
       loop    scan_disk
       retn

check_active_disk:
       mov     cl,cur_disk
       mov     al,status_disk
       shr     al,cl
       retn

resetup_partition:

if debug_mode eq 0
       push    0
endif

if debug_mode eq 1
       push    ds
endif

       pop     es
       mov     cx,3                   ;  㧮묨 ᪨
       
if debug_mode eq 0
       mov     bx,07BEh
endif

if debug_mode eq 1
       mov     bx,offset partition
endif

  loop_00:
       mov     es:[bx],byte ptr 0
       add     bx,16
       loop    loop_00
       
if debug_mode eq 0
       mov     bx,07BEh
endif

if debug_mode eq 1
       mov     bx,offset partition
endif

       xor     ax,ax
       mov     al,boot_disk
       dec     al
       shl     al,4
       add     bx,ax
       mov     es:[bx],byte ptr 80h
       mov     new_si,bx

       mov     cx,3
       
if debug_mode eq 0
       mov     bx,07BEh
endif

if debug_mode eq 1
       mov     bx,offset partition
endif

       add     bx,16*2                 ;樮㥬  ᫥ 
       mov     al,status_disk
       shl     al,5
  scan_disk_0:
       push    cx
       shl     al,1
       push    ax
       jnc     non_status_0
       mov     al,6
       jmp     done_0
  non_status_0:
       mov     al,0
  done_0:
       mov     es:[bx+4],al
       pop     ax
       pop     cx
       sub     bx,10h
       loop    scan_disk_0
       retn

set_up_font:
       mov     bp,offset font
       mov     ax,1100h
       mov     cx,128
       mov     dx,128
       mov     bx,1000h
       int     10h
       mov     ax,1103h
       mov     bl,00h
       int     10h
       retn

menu        db      ' 롮:',13,10
            db      '     : Windows`97',13,10
            db      '     : Windows`96',13,10
            db      '     : MsDos`6.22',0
cur_disk    db      1
boot_disk   db      1
status_disk db      5
new_si      dw      0

include  sec_50.inc

partition   db      64 dup (80h)

cseg    ends
        end start       